# TDT4250 examples repository

This repository contains a complete example of how to combine EMF projecs with an OSGi (bnd) workspace. The projects are divided in two subfolders, one for EMF-related projects and one for the OSGi workspace. You should _not_ import projects for both subfolders in the same Eclipse workspace.

## EMF projects

The EMF projects are contained in the **projects-ecore** folder. You can import them with **File / Import... / Existing Projects into Workspace**.

The projects revolve around the Resource Allocation (ra) example that is mentioned in previous years. The projects cover different features of EMF modeling, including constraints and OCL. Projects that use Sirius and Xtext based on the ra model are also available.

The two projects **tdt4250.ra.feature** and **tdt4250.ra.repository** are used to produce a p2 repository (update site) that can be used to deploy the plugins.

The projects are also configured to be build with Maven Tycho. It should be enough to run **mvn package** to build the projects and have the update site produced in **tdt4250.ra.repository/target/repository**. The Maven configuration is contained in the **.mvn** folder and in the **pom.xml** file. The configuration in the **.mvn** folder instructs Maven to use the Tycho plugin for "pomless" build: this allows Maven to get dependency information directly from the MANIFEST.MF file inside each plugin, without needing additional pom.xml files.

## OSGi workspace

The OSGi workspace can be found in the **projects-osgi** folder. You can import them with **File / Import... / Existing Projects into Workspace**.

The application realizes a servlet that serves data from instances of the **tdt4250.ra** Ecore metamodel, through a REST interface. That is, requests received by REST are answered with content from the model.

The **tdt4250.ra.servlet** project contains the servlet, realized as an OSGi component by the ResourceServlet class.

The **tdt4250.ra.resource** project is an example of how an XMI Ecore resource can be integrated in a plain OSGi application. The resource is in this case shipped with the bundle and it is read using the Java code generated by EMF for the metamodel. This project, and in particular the SampleResource class, depends on the **tdt4250.ra** bundle, which is actually an Eclipse plugin produced by compiling the project present in the other workspace.

The link between the two set of project is done in the **cnf/build.bnd** file, and in particular in the list of repository. The repository (update site) generated by packaging the **tdt4250.ra.repository** project is set as repository for the OSGi workspace. This is done by setting the relative path **${fileuri;../projects-ecore/tdt4250.ra.repository/target/repository/}** as **url** of the repository. The compilation process will include our EMF update site as source for bundles to be included in the final application.

The project can be built automatically with Gradle. You should use the [Gradle Wrapper](https://docs.gradle.org/current/userguide/gradle_wrapper.html), which makes sure you are using the correct version of Gradle, even if that is not installed in your system. You can run the wrapper with **./gradlew** (make sure that the file is set as executable).

With **./gradlew export** you can export all OSGi launch configurations, each in an executable JAR file. This workspace contains only one configuration The output file will be located at **tdt4250.emf.servlet/generated/distributions/executable**. Once executed, the servlet can be reached at the address `http://localhost:8080/data/sample/`.
